﻿using System;

namespace ConsoleAppAnlyTest
{
    public abstract class TrafficLightBase
    {
        private bool _g;

        private bool _g2;

        private bool _r;

        private bool _r2;

        private bool _y;

        public abstract void RunStep();

        public bool G
        {
            get
            {
                return _g;
            }
            protected set
            {
                if (_g != value)
                {
                    _g = value;
                    Console.WriteLine($"Auto Green {value}");
                }
            }
        }

        public bool G2
        {
            get
            {
                return _g2;
            }
            protected set
            {
                if (_g2 != value)
                {
                    _g2 = value;
                    Console.WriteLine($"Pedestrian Green {value}");
                }
            }
        }

        public bool R
        {
            get
            {
                return _r;
            }
            protected set
            {
                if (_r != value)
                {
                    _r = value;
                    Console.WriteLine($"Auto Red {value}");
                }
            }
        }

        public bool R2
        {
            get
            {
                return _r2;
            }
            protected set
            {
                if (_r2 != value)
                {
                    _r2 = value;
                    Console.WriteLine($"Pedestrian Red  {value}");
                }
            }
        }

        public bool Y
        {
            get
            {
                return _y;
            }
            protected set
            {
                if (_y != value)
                {
                    _y = value;
                    Console.WriteLine($"Auto Yellow {value}");
                }
            }
        }
    }
}
